﻿using System;
using System.IO;

namespace GameUtils.Audio
{
    public abstract class AudioEngine : IEngineComponent
    {
        bool IEngineComponent.IsCompatibleTo(IEngineComponent component)
        {
            return !(component is AudioEngine);
        }

        public object Tag { get; set; }

        public abstract AudioHandle CreateHandle(Stream stream);
        public abstract AudioHandle CreateHandle(string file);

        private bool disposed;

        public void Dispose()
        {
            if (!disposed)
            {
                Dispose(true);
                GC.SuppressFinalize(this);

                disposed = true;
            }
        }

        protected virtual void Dispose(bool disposing)
        { }

        ~AudioEngine()
        {
            Dispose(false);
        }
    }
}
